struct Pixel;
class DNA;
class Animal;

class World
{
public:
	World( int imagec, char** imagev );

	void Display(); //OpenGL display function
	void FitnessCheck();
	void ImageCheck();
	void RenderChase();
	void RenderImage();
	void RenderVisible( Animal* a );
	void Resize( int w, int h ); //screen resize function

	void Load();
	void InsertAnimal( DNA* d );
	void Procreate( DNA* d );

	void CycleDisplayBuffer();
	void CycleCameraMode();
	void Step();

	void Promote(); //promote back buffer to front

	Animal* pop; //ptr to highest-fitness animal
	int pop_c;

	Animal* chase; //chasecam target

	int fit_cycle;
	int image_cycle;

	char** image_v;
	int image_c;
	int image_i;

	int image_w, image_h;
	Pixel** image_p;

	int screen_w, screen_h;

	float world_l, world_r, world_t, world_b;

	char display_buffer;
	char camera_mode;
};
